// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_failed_contract_distributions.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const listFailedContractDistributions = `-- name: ListFailedContractDistributions :many

SELECT
    peer_id,
    content_hash,
    signature,
    action,
    next_attempt_at,
    reason,
    attempts,
    last_attempt_at
FROM
    contracts.failed_distributions
WHERE
    $1::text IS NULL OR content_hash = $1::text
`

type ListFailedContractDistributionsRow struct {
	PeerID        string
	ContentHash   string
	Signature     string
	Action        ContractsDistributionAction
	NextAttemptAt pgtype.Timestamptz
	Reason        string
	Attempts      int32
	LastAttemptAt pgtype.Timestamptz
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
func (q *Queries) ListFailedContractDistributions(ctx context.Context, contentHash pgtype.Text) ([]*ListFailedContractDistributionsRow, error) {
	rows, err := q.db.Query(ctx, listFailedContractDistributions, contentHash)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListFailedContractDistributionsRow{}
	for rows.Next() {
		var i ListFailedContractDistributionsRow
		if err := rows.Scan(
			&i.PeerID,
			&i.ContentHash,
			&i.Signature,
			&i.Action,
			&i.NextAttemptAt,
			&i.Reason,
			&i.Attempts,
			&i.LastAttemptAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
